#include "config.h"
#include "defines.h"
#include <time.h>
#include <unistd.h>
#include "itoa.h"
#include "mystring.h"
#include "hostname.h"

mystring make_date()
{
  char buf[256];
  time_t t = time(0);
  struct tm* l = localtime(&t);
  strftime(buf, 256, "%a, %d %b %Y %H:%M:%S ", l);
  long tznum = timezone/60;
  if(tznum < 0)
    tznum = -tznum;
  long tzmins = tznum % 60;
  long tzhours = tznum / 60;
  char sign[2];
  if(timezone > 0)
    sign[0] = '+';
  else
    sign[0] = '-';
  sign[1] = 0;
  return mystring(buf, sign, itoa(tzhours, 2), itoa(tzmins, 2));
}

// Message ID strings have the form YYYY.MM.DD.HH.MM.SS.PID.nullmailer@HOST
mystring make_messageid()
{
  time_t t = time(0);
  char buf[100];
  strftime(buf, 100, "<%Y.%m.%d.%H.%M.%S.", gmtime(&t));
  return mystring(buf, itoa(getpid()), ".nullmailer@", hostname(), ">");
}
